/**
 * @file  sci.c
 * @brief SCIhCo
 *
 *
 * {\tgEFA̒쌠͍쐬ł()kldqL̂ƂA
 * ()kldq́Aȉ (1)`(3) ̏𖞂ꍇɌA
 * {\tgEFAi{\tgEFAς̂܂ށBȉj
 * gpEEρEĔzziȉApƌĂԁj邱Ƃ𖳏ŋB
 *
 * (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́AL̒
 *	   \A̗pÂ܂܂̌`Ń\[XR[hɊ܂܂
 *	   邱ƁB
 * (2) {\tgEFÄꕔ܂͑SĂ𖳒fœ]ڂ邱Ƃ֎~
 *	   ƂBGȂǂ֏ЉE^̏ꍇ()kldqɘA肢܂B
 * (3) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹Q
 *	   A()kldq͈؂̐ӔC𕉂Ȃ̂ƂB
 *
 * Copyright (C) Hokuto denshi Co,Ltd. 2018
 */

/*----------------------------------------------------------------------
	CN[h
----------------------------------------------------------------------*/
#include <machine.h>
#include "iodefine.h"
#include "sci.h"
#include "board.h"
#include "ada_if_userdef.h"
#include "Config_CMT0.h"

/*----------------------------------------------------------------------
	荞
----------------------------------------------------------------------*/

// SCI1 RXI1
#pragma interrupt (Intr_SCI1_RXI1(vect=60))
void Intr_SCI1_RXI1(void);

// SCI1 TXI1
#pragma interrupt (Intr_SCI1_TXI1(vect=61))
void Intr_SCI1_TXI1(void);

/*----------------------------------------------------------------------
	萔`
----------------------------------------------------------------------*/


/*----------------------------------------------------------------------
	vg^Cv錾
----------------------------------------------------------------------*/
static void sci_init_port( void );
static void sci_wait( unsigned long msec );

void sci_init( void );
char sci_read_char( void );
void sci_write_char( unsigned char c );
void sci_write_str( char *str );
void sci_write_uint8_hex( unsigned char n );
void sci_wite_uint16_hex( unsigned short n );
void sci_write_uint32_hex( unsigned long n );
void sci_write_uint8( unsigned char n );
void sci_write_uint16( unsigned short n );
void sci_write_uint32( unsigned long n );
void sci_write_int8( char n );
void sci_write_int16( short n );
void sci_write_int32( long n );

/*----------------------------------------------------------------------
	O[oϐ
----------------------------------------------------------------------*/

unsigned char g_sci_tx_buf[SCI_BUF_SIZE];
unsigned short g_sci_tx_buf_wp=0, g_sci_tx_buf_rp=0;

char g_sci_rx_buf;

unsigned long g_sci_rx_flag;
unsigned long g_sci_tx_wait_flag;	//0:obt@t̏ꍇ҂, 1:obt@t̏ꍇf[^j, 2:obt@gȂ

/*----------------------------------------------------------------------
	O[oϐit@Cj
----------------------------------------------------------------------*/
static const char disp_table[] = "0123456789ABCDEF";		// e[u

/*----------------------------------------------------------------------
	\[XR[h
----------------------------------------------------------------------*/
void Intr_SCI1_RXI1(void)
{
	//M荞݊֐
		
	if( ( SSR.BYTE & 0x38 ) != 0 )
	{
		SSR.BYTE &= ~0x38;
	}
	else
	{
		g_sci_rx_flag = 1;
		g_sci_rx_buf = (char)RDR;
	}
}

void Intr_SCI1_TXI1(void)
{
	//M荞݊֐
	
}


static void sci_init_port( void )
{
	//I/O|[g֐
	
	//߂l Ȃ
	
	// Ȃ

#if (PIN_NO == 176)
	
	// TXD1 : PF0
	// RXD1 : PF2

	PORTF.PDR.BIT.B0 = 0;
	PORTF.PDR.BIT.B2 = 0;

	MPC.PWPR.BIT.B0WI  = 0;
	MPC.PWPR.BIT.PFSWE = 1;

	MPC.PF0PFS.BIT.PSEL = 0x0A;
	MPC.PF2PFS.BIT.PSEL = 0x0A;

	MPC.PWPR.BIT.PFSWE = 0;

	PORTF.PMR.BIT.B0 = 1;
	PORTF.PMR.BIT.B2 = 1;

#elif (PIN_NO == 144)
	
	// TXD1 : P26
	// RXD1 : P30

	PORT2.PDR.BIT.B6 = 0;
	PORT3.PDR.BIT.B0 = 0;

	MPC.PWPR.BIT.B0WI  = 0;
	MPC.PWPR.BIT.PFSWE = 1;

	MPC.P26PFS.BIT.PSEL = 0x0A;
	MPC.P30PFS.BIT.PSEL = 0x0A;

	MPC.PWPR.BIT.PFSWE = 0;

	PORT2.PMR.BIT.B6 = 1;
	PORT3.PMR.BIT.B0 = 1;

#endif

}

static void sci_wait( unsigned long msec )
{
	//EFCg֐
	
	//߂l Ȃ
	
	// Ȃ
	
	volatile unsigned long i;

	for( i = 0; i < ( 500 * msec ); i++ )
	{
		;
	}
}

#if (USE_SCI == 1)
	//SCIgp

void sci_init( void )
{
	//SCI֐
	
	//߂l Ȃ
	
	// Ȃ
	
	SYSTEM.PRCR.WORD = 0xA502;			// veNgWX^
	MSTP(SCI1) = 0;						// SCI1
	SYSTEM.PRCR.WORD = 0xA500;			// veNgWX^ݒ

	//|[g
	sci_init_port();

	//荞ݐݒ
	IPR(SCI1, RXI1) = 8;				//M荞 Dx=8
	IPR(SCI1, TXI1) = 8;				//M荞 Dx=8
	
	IEN(SCI1, RXI1) = 1;				//M荞ݗL
	IEN(SCI1, TXI1) = 1;				//M荞ݗL

	SCR.BYTE		= 0x00;

	//xݒ
	//SEMR.BYTE	= 0x00;		// ABCS = 0, BGDM = 0;
	//SEMR.BYTE	= 0x10;		// ABCS = 1, BGDM = 0;
	SEMR.BYTE	= 0x50;		// ABCS = 1, BGDM = 1;
	SMR.BYTE	= 0x00;		// CKS = 0
	SCMR.BYTE	= 0x00;

	BRR			= 0x40;		// PCLKB = 60MHz , 115200 bps (덷=0.16%)   ABCS = 1, BGDM = 1;

	//SCR.BYTE	= 0xF0;		// M荞݋AM荞݋AM
	SCR.BYTE	= 0x70;		// M荞݋AM

	g_sci_rx_flag = 0;
	
	g_sci_tx_buf_wp = 0;
	g_sci_tx_buf_rp = 0;
	
	g_sci_tx_wait_flag = 0;
	
	R_Config_CMT0_Start();			//CMT0i100usj
			
	sci_wait(10);
}


void sci_write_char( unsigned char c )
{
	//1o͊֐iobt@OŁj
	
	//߂l Ȃ
	
	//
	//  c : o͂镶R[h
	
	unsigned short index;
	
	if(g_sci_tx_wait_flag == 2)
	{
		while(SSR.BIT.TDRE == 0)
		{
			__nop();
		}
		
		TDR = c;
		
		return;
	}
	
	index = g_sci_tx_buf_wp + 1;
	if(index >= SCI_BUF_SIZE) index = 0;
	
	if(index == g_sci_tx_buf_rp)
	{
		//obt@t
		
		if(g_sci_tx_wait_flag == 1) return;			//waittO1̎̓obt@Ƀf[^i[return
		else
		{
			while(index == g_sci_tx_buf_rp)			//o͂g_sci_tx_buf_rpiނ܂ő҂
			{
				__nop();
			}
		}
	}
	
	g_sci_tx_buf_wp = index;
	
	g_sci_tx_buf[g_sci_tx_buf_wp] = c;
	
}

void sci_write_flush(void)
{
	//obt@o͊֐
	
	//߂l Ȃ
	
	//@Ȃ

	//obt@ɂȂ܂ő҂܂
	
	while(g_sci_tx_buf_wp != g_sci_tx_buf_rp)
	{
		__nop();
	}
}

char sci_read_char( void )
{
	//M֐
	
	//߂l R[h
	
	//@Ȃ
	
	if( g_sci_rx_flag != 1 )
	{
		return	0xff;			//f[^MȂ
	}

	g_sci_rx_flag = 0;
	
	return g_sci_rx_buf;
}

void sci_write_str( char *str )
{
	//o͊֐
	
	//߂l Ȃ
	
	//
	//  *str : o̓f[^̃|C^i\0I[j
	
	while( *str != '\0' )
	{
		/* I[o */
		if( *str == '\n' )
		{
			/* so */
			sci_write_char(0x0d);
			sci_write_char(0x0a);
		}
		/* o */
		else
		{
			sci_write_char( *str );
		}
		str++;
	}
}

void sci_write_uint8_hex( unsigned char n )
{
	//1oCgo͊֐
	
	//߂l Ȃ
	
	//
	//  n : \f[^
	
	//
	//00-FF16i2Ńf[^\܂
	
	sci_write_char( disp_table[ ((n & 0xf0) >> 4) ] );
	sci_write_char( disp_table[ (n & 0x0f) ] );
}

void sci_write_uint16_hex( unsigned short n )
{
	//2oCgo͊֐
	
	//߂l Ȃ
	
	//
	//  n : \f[^
	
	//
	//0000-FFFF16i4Ńf[^\܂
	
	unsigned long i;
	char data[2];

	data[1] = (unsigned char)( (n & 0x00ff) );
	data[0] = (unsigned char)( (n & 0xff00) >> 8 );

	for( i = 0; i < 2; i++ )
	{
		sci_write_char( disp_table[ ((data[i] & 0xf0) >> 4) ] );
		sci_write_char( disp_table[ (data[i] & 0x0f) ] );
	}
}

void sci_wite_uint32_hex( unsigned long n )
{
	//4oCgo͊֐
	
	//߂l Ȃ
	
	//
	//  n : \f[^
	
	//
	//00000000-FFFFFFFF16i8Ńf[^\܂
	
	unsigned long i;
	char data[4];

	data[3] = (unsigned char)( n & 0x000000ff );
	data[2] = (unsigned char)( (n & 0x0000ff00) >> 8 );
	data[1] = (unsigned char)( (n & 0x00ff0000) >> 16 );
	data[0] = (unsigned char)( (n & 0xff000000) >> 24 );

	for( i = 0; i < 4; i++ )
	{
		sci_write_char( disp_table[ ((data[i] & 0xf0) >> 4) ] );
		sci_write_char( disp_table[ (data[i] & 0x0f) ] );
	}
}

void sci_write_uint8( unsigned char n )
{
	//lo͊֐
	
	//߂l Ȃ
	
	//
	//  n : \f[^
	
	//
	//1oCg̐l10iŃf[^\܂i̐̂݁j
	
	unsigned char d[5];
	
	d[0] = n % 10;
	n /= 10;
	d[1] =  n % 10;
	n /= 10;
	d[2] = n % 10;

	if(d[2] != 0)
	{
		sci_write_char(disp_table[d[2]]);
		sci_write_char(disp_table[d[1]]);
	}
	else if(d[1] != 0)
	{
		sci_write_char(disp_table[d[1]]);
	}

	sci_write_char(disp_table[d[0]]);
		
}

void sci_write_uint16( unsigned short n )
{
	//lo͊֐
	
	//߂l Ȃ
	
	//
	//  n : \f[^
	
	//
	//2oCg̐l10iŃf[^\܂i̐̂݁j
	
	unsigned char d[5];
	
	d[0] = n % 10;
	n /= 10;
	d[1] =  n % 10;
	n /= 10;
	d[2] =  n % 10;
	n /= 10;
	d[3] =  n % 10;
	n /= 10;
	d[4] = n % 10;
	
	if(d[4] != 0)
	{
		sci_write_char(disp_table[d[4]]);
		sci_write_char(disp_table[d[3]]);
		sci_write_char(disp_table[d[2]]);
		sci_write_char(disp_table[d[1]]);
	}
	else if(d[3] != 0)
	{
		sci_write_char(disp_table[d[3]]);
		sci_write_char(disp_table[d[2]]);
		sci_write_char(disp_table[d[1]]);
	}
	else if(d[2] != 0)
	{
		sci_write_char(disp_table[d[2]]);
		sci_write_char(disp_table[d[1]]);
	}
	else if(d[1] != 0)
	{
		sci_write_char(disp_table[d[1]]);
	}

	sci_write_char(disp_table[d[0]]);		
}

void sci_write_uint32( unsigned long n )
{
	//lo͊֐
	
	//߂l Ȃ
	
	//
	//  n : \f[^
	
	//
	//4oCg̐l10iŃf[^\܂i̐̂݁j
	
   unsigned char d[10];

    d[0] = n % 10;
    n /= 10;
    d[1] = n % 10;
    n /= 10;
    d[2] = n % 10;
    n /= 10;
    d[3] = n % 10;
    n /= 10;
    d[4] = n % 10;
    n /= 10;
    d[5] = n % 10;
    n /= 10;
    d[6] = n % 10;
    n /= 10;
    d[7] = n % 10;
    n /= 10;
    d[8] = n % 10;
    n /= 10;
    d[9] = n % 10;

    if(d[9] != 0)
    {
        sci_write_char(disp_table[d[9]]);
        sci_write_char(disp_table[d[8]]);
        sci_write_char(disp_table[d[7]]);
        sci_write_char(disp_table[d[6]]);
        sci_write_char(disp_table[d[5]]);
        sci_write_char(disp_table[d[4]]);
        sci_write_char(disp_table[d[3]]);
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[8] != 0)
    {
        sci_write_char(disp_table[d[8]]);
        sci_write_char(disp_table[d[7]]);
        sci_write_char(disp_table[d[6]]);
        sci_write_char(disp_table[d[5]]);
        sci_write_char(disp_table[d[4]]);
        sci_write_char(disp_table[d[3]]);
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[7] != 0)
    {
        sci_write_char(disp_table[d[7]]);
        sci_write_char(disp_table[d[6]]);
        sci_write_char(disp_table[d[5]]);
        sci_write_char(disp_table[d[4]]);
        sci_write_char(disp_table[d[3]]);
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[6] != 0)
    {
        sci_write_char(disp_table[d[6]]);
        sci_write_char(disp_table[d[5]]);
        sci_write_char(disp_table[d[4]]);
        sci_write_char(disp_table[d[3]]);
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[5] != 0)
    {
        sci_write_char(disp_table[d[5]]);
        sci_write_char(disp_table[d[4]]);
        sci_write_char(disp_table[d[3]]);
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[4] != 0)
    {
        sci_write_char(disp_table[d[4]]);
        sci_write_char(disp_table[d[3]]);
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[3] != 0)
    {
        sci_write_char(disp_table[d[3]]);
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[2] != 0)
    {
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[1] != 0)
    {
        sci_write_char(disp_table[d[1]]);
    }

    sci_write_char(disp_table[d[0]]);
}

void sci_write_int8(char n)
{
	//lo͊֐
	
	//߂l Ȃ
	
	//
	//  n : \f[^
	
	//
	//1oCg̐l10iŃf[^\܂itj

    unsigned char d[3];

    if((n & 0x80) == 0x80)
    {
        sci_write_char('-');
        n = (char)~n;
        n = (char)(n + 1);
    }

    d[0]  = n % 10;
    n  /= 10;
    d[1]  = n % 10;
    n  /= 10;
    d[2]  = n % 10;

    if(d[2] != 0)
    {
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[1] != 0)
    {
        sci_write_char(disp_table[d[1]]);
    }

    sci_write_char(disp_table[d[0]]);
}

void sci_write_int16( short n )
{
	//lo͊֐
	
	//߂l Ȃ
	
	//
	//  n : \f[^
	
	//
	//2oCg̐l10iŃf[^\܂itj
	
	unsigned char d[5];
	
	if(n < 0)
    {
        sci_write_char('-');
        n = (short)(n * (-1));
    }
	
	d[0] = n % 10;
	n /= 10;
	d[1] =  n % 10;
	n /= 10;
	d[2] =  n % 10;
	n /= 10;
	d[3] =  n % 10;
	n /= 10;
	d[4] = n % 10;
	
	if(d[4] != 0)
	{
		sci_write_char(disp_table[d[4]]);
		sci_write_char(disp_table[d[3]]);
		sci_write_char(disp_table[d[2]]);
		sci_write_char(disp_table[d[1]]);
	}
	else if(d[3] != 0)
	{
		sci_write_char(disp_table[d[3]]);
		sci_write_char(disp_table[d[2]]);
		sci_write_char(disp_table[d[1]]);
	}
	else if(d[2] != 0)
	{
		sci_write_char(disp_table[d[2]]);
		sci_write_char(disp_table[d[1]]);
	}
	else if(d[1] != 0)
	{
		sci_write_char(disp_table[d[1]]);
	}

	sci_write_char(disp_table[d[0]]);		
}

void sci_write_int32( long n )
{
	//lo͊֐
	
	//߂l Ȃ
	
	//
	//  n : \f[^
	
	//
	//4oCg̐l10iŃf[^\܂itj
	
   unsigned char d[10];
   
    if(n < 0)
    {
        sci_write_char('-');
        n *= -1;
    }

    d[0] = n % 10;
    n /= 10;
    d[1] = n % 10;
    n /= 10;
    d[2] = n % 10;
    n /= 10;
    d[3] = n % 10;
    n /= 10;
    d[4] = n % 10;
    n /= 10;
    d[5] = n % 10;
    n /= 10;
    d[6] = n % 10;
    n /= 10;
    d[7] = n % 10;
    n /= 10;
    d[8] = n % 10;
    n /= 10;
    d[9] = n % 10;

    if(d[9] != 0)
    {
        sci_write_char(disp_table[d[9]]);
        sci_write_char(disp_table[d[8]]);
        sci_write_char(disp_table[d[7]]);
        sci_write_char(disp_table[d[6]]);
        sci_write_char(disp_table[d[5]]);
        sci_write_char(disp_table[d[4]]);
        sci_write_char(disp_table[d[3]]);
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[8] != 0)
    {
        sci_write_char(disp_table[d[8]]);
        sci_write_char(disp_table[d[7]]);
        sci_write_char(disp_table[d[6]]);
        sci_write_char(disp_table[d[5]]);
        sci_write_char(disp_table[d[4]]);
        sci_write_char(disp_table[d[3]]);
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[7] != 0)
    {
        sci_write_char(disp_table[d[7]]);
        sci_write_char(disp_table[d[6]]);
        sci_write_char(disp_table[d[5]]);
        sci_write_char(disp_table[d[4]]);
        sci_write_char(disp_table[d[3]]);
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[6] != 0)
    {
        sci_write_char(disp_table[d[6]]);
        sci_write_char(disp_table[d[5]]);
        sci_write_char(disp_table[d[4]]);
        sci_write_char(disp_table[d[3]]);
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[5] != 0)
    {
        sci_write_char(disp_table[d[5]]);
        sci_write_char(disp_table[d[4]]);
        sci_write_char(disp_table[d[3]]);
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[4] != 0)
    {
        sci_write_char(disp_table[d[4]]);
        sci_write_char(disp_table[d[3]]);
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[3] != 0)
    {
        sci_write_char(disp_table[d[3]]);
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[2] != 0)
    {
        sci_write_char(disp_table[d[2]]);
        sci_write_char(disp_table[d[1]]);
    }
    else if(d[1] != 0)
    {
        sci_write_char(disp_table[d[1]]);
    }

    sci_write_char(disp_table[d[0]]);
}

#else
	//SCIgpȂ
	
void sci_init( void )
{
}

char sci_read_char( void )
{
	return 0xff;
}

void sci_write_char( unsigned char c )
{
}

void sci_write_flush(void)
{
}

void sci_write_str( char *str )
{
}

void sci_write_uint8_hex( unsigned char n )
{
}

void sci_wite_uint16_hex( unsigned short n )
{
}

void sci_write_uint32_hex( unsigned long n )
{
}

void sci_write_uint8( unsigned char n )
{
}

void sci_write_uint16( unsigned short n )
{
}

void sci_write_uint32( unsigned long n )
{
}

void sci_write_int8( char n )
{
}

void sci_write_int16( short n )
{
}

void sci_write_int32( long n )
{
}
	
	
#endif
/* End of File */
